  MEMBER

!  INCLUDE('Errors.clw'),ONCE
  INCLUDE('getsnmp.inc'),ONCE
!  INCLUDE('Wsock32.clw'),ONCE

    MAP
      INCLUDE('CWUTIL.INC'),ONCE
      MODULE('WS2_32.LIB')
        GetLastError(),long,pascal
      END
!      MODULE('')
!        SaveLog(STRING Pref, STRING Msg)
!      END
    END

GetSNMPClass.Construct        PROCEDURE
  CODE

GetSNMPClass.Destruct         PROCEDURE
  CODE

GetSNMPClass.Init PROCEDURE(STRING Host, STRING Community)
  CODE
  SELF.Host = Host
  SELF.Community = Community
  SELF.requestType = SNMP_PDU_GETNEXT !SNMP_PDU_GET SNMP_PDU_INFORM

  SELF.session = SnmpMgrOpen(SELF.Host, SELF.Community, SELF.timeout, SELF.retries)
  IF SELF.session = 0
    !SaveLog('snmp','SnmpMgrOpen Error ' & GetLastError())
    RETURN
  END
  !SaveLog('snmp','Start ' & SELF.Host)

GetSNMPClass.Kill PROCEDURE
  CODE
  IF SELF.session = 0 THEN RETURN.
  IF (SnmpMgrClose(SELF.session)) = 0
     !SaveLog('snmp','SnmpMgrClose Error ' & GetLastError())
  ELSE
     !SaveLog('snmp','SnmpMgrClose OK')
  END
  SELF.session = 0

GetSNMPClass.Run PROCEDURE(SHORT Cnv, STRING Descr, STRING Oid, *SNMPResultQueueType Res)
VarTmp           &RFC1157VarBind
LocIdx  LONG
LocStr  CSTRING(201)
  CODE
  IF SELF.session = 0 THEN RETURN.
  !SaveLog('snmp','Run ' & oid)
  SELF.Result &= Res
  SELF.Oid   = Oid
  SELF.Cnv   = Cnv
  SELF.NameOID = Descr

  IF SnmpMgrStrToOid(SELF.Oid, SELF.reqObject) = 0
    !SaveLog('snmp','SnmpMgrStrToOid Error: Invalid oid: ' & oid)
    RETURN
  END

  SELF.variableBindings.len = 1
  SELF.variableBindings.list = SnmpUtilMemAlloc(size(RFC1157VarBind))
  IF SELF.variableBindings.list = 0
    !SaveLog('snmp','Error: Error allocating oid')
    RETURN
  END

  VarTmp &= SELF.variableBindings.list+0
  VarTmp.name = SELF.reqObject
  VarTmp.value.asnType = ASN_OCTETSTRING

  IF SnmpUtilOidCpy(SELF.rootOid, VarTmp.name ) = 0
    !SaveLog('SNMP','SnmpUtilOidCpy Error ' & GetLastError())
    RETURN
  END

  LOOP
    IF SnmpMgrRequest(SELF.session, SELF.requestType, SELF.variableBindings, SELF.errorStatus, SELF.errorIndex) = 0
      !SaveLog('snmp','SnmpMgrRequest Error ' & GetLastError())
      BREAK
    END
    if (SELF.errorStatus > 0)
      !SaveLog('snmp','errorStatus ' & SELF.errorStatus)
      !SaveLog('snmp','errorIndex ' & SELF.errorIndex)
      BREAK
    END
    VarTmp &= SELF.variableBindings.list+0
    if (SnmpUtilOidNCmp(VarTmp.name, SELF.rootOid, SELF.rootOid.idLength )) <> 0
      !SaveLog('snmp','SnmpUtilOidNCmp Break')
      BREAK
    END
    SELF.GetVariableBindings
  END
  SnmpUtilMemFree(SELF.variableBindings.list)
!  SnmpUtilOidFree(SELF.reqObject)
  SnmpUtilOidFree(SELF.rootOid)

  RETURN

GetSNMPClass.Get PROCEDURE(LONG DescrID, SHORT Cnv, STRING Descr, STRING Oid, *SNMPResultQueueType Res)
VarTmp           &RFC1157VarBind
LocIdx  LONG
LocStr  CSTRING(201)
  CODE
  IF SELF.session = 0 THEN RETURN.
  SELF.DescrID = DescrId
  SELF.requestType = SNMP_PDU_GET !SNMP_PDU_INFORM
  !SaveLog('snmp','Run ' & oid)
  SELF.Result &= Res
  SELF.Oid   = Oid
  SELF.Cnv   = Cnv
  SELF.NameOID = Descr

  IF SnmpMgrStrToOid(SELF.Oid, SELF.reqObject) = 0
    !SaveLog('snmp','SnmpMgrStrToOid Error: Invalid oid: ' & oid)
    RETURN
  END

  SELF.variableBindings.len = 1
  SELF.variableBindings.list = SnmpUtilMemAlloc(size(RFC1157VarBind))
  IF SELF.variableBindings.list = 0
    !SaveLog('snmp','Error: Error allocating oid')
    RETURN
  END

  VarTmp &= SELF.variableBindings.list+0
  VarTmp.name = SELF.reqObject
  VarTmp.value.asnType = ASN_OCTETSTRING

  IF SnmpUtilOidCpy(SELF.rootOid, VarTmp.name ) = 0
    !SaveLog('SNMP','SnmpUtilOidCpy Error ' & GetLastError())
    RETURN
  END

  LOOP
    IF SnmpMgrRequest(SELF.session, SELF.requestType, SELF.variableBindings, SELF.errorStatus, SELF.errorIndex) = 0
      !SaveLog('snmp','SnmpMgrRequest Error ' & GetLastError())
      BREAK
    END
    if (SELF.errorStatus > 0)
      !SaveLog('snmp','errorStatus ' & SELF.errorStatus)
      !SaveLog('snmp','errorIndex ' & SELF.errorIndex)
      BREAK
    END
    VarTmp &= SELF.variableBindings.list+0
    if (SnmpUtilOidNCmp(VarTmp.name, SELF.rootOid, SELF.rootOid.idLength )) <> 0
      !SaveLog('snmp','SnmpUtilOidNCmp Break')
      BREAK
    END
    SELF.GetVariableBindings
    BREAK
  END
  SnmpUtilMemFree(SELF.variableBindings.list)
!  SnmpUtilOidFree(SELF.reqObject)
  SnmpUtilOidFree(SELF.rootOid)
  RETURN

GetSNMPClass.GetVariableBindings PROCEDURE
cnvByteResult    CSTRING(100)
cnvULONG         &ULONG
cnvBYTE          &BYTE
cnvCHAR          &STRING
cnvIP            GROUP(sntp_any_IPaddres).
LocOID           &CSTRING
LocValue         &CSTRING
VarTmp           &RFC1157VarBind
  CODE
  !CLEAR(cnvByteResult)
  cnvByteResult = SELF.NameOID & ' '
  VarTmp &= SELF.variableBindings.list+0
  IF VarTmp.name.idLength > 0
    LOOP i# = 0 TO (VarTmp.name.idLength - 1)
      cnvULONG &= VarTmp.name.ids + (i# * 4)
      cnvByteResult = cnvByteResult & '.' & cnvULONG
    END
    LocOID &= SELF.NewCstring(cnvByteResult)
  END

  CLEAR(cnvByteResult)
  CASE VarTmp.value.asnType
  OF ASN_INTEGER
    !!SaveLog('snmp','ASN_INTEGER ' & VarTmp.value.Anynumber)
    LocValue &= SELF.NewCstring(VarTmp.value.Anynumber)
  OF ASN_BITS                                             
    !!SaveLog('snmp','ASN_BITS ')                         
    IF VarTmp.value.Anybits.length > 0                       
      LOOP i# = 0 TO (VarTmp.value.Anybits.length - 1)       
        cnvBYTE &= VarTmp.value.Anybits.stream + i#          
        cnvByteResult = cnvByteResult & ' ' & ByteToHex(cnvBYTE)
      END                                                 
      LocValue &= SELF.NewCstring(cnvByteResult)
    END                                                   
  OF ASN_OCTETSTRING                                      
    IF VarTmp.value.Anystring.length > 0                     
      CASE SELF.Cnv
      OF SNMPCnv:DisplayString
        !cnvCHAR &= VarTmp.value.Anystring.stream+0
        snmp_memcpy(ADDRESS(cnvByteResult),VarTmp.value.Anystring.stream,VarTmp.value.Anystring.length)
        !LOOP i# = 1 TO VarTmp.value.Anystring.length
        !  cnvByteResult[i#] = cnvCHAR[i#]
        !END
        cnvByteResult[VarTmp.value.Anystring.length+1] = '<0>'
      OF SNMPCnv:Default
        LOOP i# = 0 TO (VarTmp.value.Anystring.length - 1)
          cnvBYTE &= VarTmp.value.Anystring.stream + i#
          cnvByteResult = cnvByteResult & ' ' & cnvBYTE
        END
      OF SNMPCnv:PhysAddress
        LOOP i# = 0 TO (VarTmp.value.Anystring.length - 1)
          cnvBYTE &= VarTmp.value.Anystring.stream + i#
!          cnvByteResult = cnvByteResult & ' ' & cnvBYTE
          IF i# = 0
            cnvByteResult = ByteToHex(cnvBYTE)
          ELSE
            cnvByteResult = cnvByteResult & ':' & LOWER(ByteToHex(cnvBYTE))
          END
        END
      END
      LocValue &= SELF.NewCstring(cnvByteResult)
    END
  OF ASN_NULL
    !SaveLog('snmp','ASN_NULL')
  OF ASN_OBJECTIDENTIFIER
    !SaveLog('snmp','ASN_OBJECTIDENTIFIER')
  OF ASN_INTEGER32
    !!SaveLog('snmp','ASN_INTEGER32 ' & VarTmp.value.Anynumber)
    LocValue &= SELF.NewCstring(VarTmp.value.Anynumber)
  OF ASN_SEQUENCE
    !SaveLog('snmp','ASN_SEQUENCE')
  OF ASN_SEQUENCEOF
    !SaveLog('snmp','ASN_SEQUENCEOF')
    !LocValue &= SELF.NewCstring(VarTmp.value.Anycounter)
  OF ASN_IPADDRESS
    IF VarTmp.value.Anyaddress.length = 4
      snmp_memcpy(ADDRESS(cnvIP.IpAddressHex),VarTmp.value.Anyaddress.stream,4)
      cnvByteResult = cnvIP.IpAddressHexOvr[1] & '.' & cnvIP.IpAddressHexOvr[2] & '.' & cnvIP.IpAddressHexOvr[3] & '.' & cnvIP.IpAddressHexOvr[4]
      !!SaveLog('snmp','ASN_IPADDRESS ' & cnvIP.IpAddressHexOvr[1] & '.' & cnvIP.IpAddressHexOvr[2] & '.' & cnvIP.IpAddressHexOvr[3] & '.' & cnvIP.IpAddressHexOvr[4])
      LocValue &= SELF.NewCstring( cnvByteResult)
    END
  OF ASN_COUNTER32
    !!SaveLog('snmp','ASN_COUNTER32 ')
    LocValue &= SELF.NewCstring(VarTmp.value.Anycounter)
  OF ASN_GAUGE32
    !!SaveLog('snmp','ASN_GAUGE32 ' & VarTmp.value.Anygauge)
    LocValue &= SELF.NewCstring(VarTmp.value.Anygauge)
  OF ASN_TIMETICKS
    !!SaveLog('snmp','ASN_TIMETICKS' & VarTmp.value.Anyticks)
    LocValue &= SELF.NewCstring(VarTmp.value.Anyticks)
  OF ASN_OPAQUE
    !SaveLog('snmp','ASN_OPAQUE')
  OF ASN_COUNTER64
    !SaveLog('snmp','ASN_COUNTER64 ')
    LocValue &= SELF.NewCstring(VarTmp.value.Anycounter64.HighPart & VarTmp.value.Anycounter64.LowPart)
  OF ASN_UNSIGNED32
    !!SaveLog('snmp','ASN_UNSIGNED32' & VarTmp.value.Anyunsigned32)
    LocValue &= SELF.NewCstring(VarTmp.value.Anyunsigned32)
  END
  IF NOT (LocOID &= NULL)
    SELF.Result.Oid &= LocOID
    LocOID &= NULL
  ELSE
    SELF.Result.Oid &= NULL
  END
  IF NOT (LocValue &= NULL)
    SELF.Result.Value &= LocValue
    LocValue &= NULL
  ELSE
    SELF.Result.Value &= NULL
  END
  SELF.Result.Id = SELF.DescrId
  ADD(SELF.Result)

GetSNMPClass.NewCstring       PROCEDURE(STRING Msg)
LocRet   &CSTRING
  CODE
  LocRet &= NEW(CSTRING(LEN(Msg)+1))
  LocRet = Msg
  RETURN LocRet
